import { HMSAction } from './HMSAction';
import { CodeMessage } from './HMSErrors';
export declare class HMSExceptionBuilder {
    private readonly cm;
    private _action;
    private _errorInfo;
    constructor(codeMessage: CodeMessage);
    action(action: HMSAction): this;
    errorInfo(errorInfo: string): this;
    static from(code: number, message: string, requiresAction?: boolean, requiresErrorInfo?: boolean): HMSExceptionBuilder;
    build(): HMSException;
}
export default class HMSException extends Error {
    readonly code: number;
    readonly title: string;
    constructor(code: number, title: string, message: string);
}
