import { HMSAudioCodec } from '../codec';
export declare class HMSAudioTrackSettingsBuilder {
    private _volume;
    private _codec;
    private _maxBitrate;
    private _deviceId;
    private _advanced;
    volume(volume: number): this;
    codec(codec: HMSAudioCodec): this;
    maxBitrate(maxBitrate: number): this;
    deviceId(deviceId: string): this;
    advanced(advanced: Array<MediaTrackConstraintSet>): this;
    build(): HMSAudioTrackSettings;
}
export default class HMSAudioTrackSettings {
    readonly volume: number;
    readonly codec: HMSAudioCodec;
    readonly maxBitrate: number;
    readonly deviceId: string;
    readonly advanced: Array<MediaTrackConstraintSet>;
    constructor(volume: number, codec: HMSAudioCodec, maxBitrate: number, deviceId: string, advanced: Array<MediaTrackConstraintSet>);
    toConstraints(): MediaTrackConstraints;
}
