import { HMSVideoCodec } from '../codec';
export declare class HMSVideoResolution {
    readonly width: number;
    readonly height: number;
    constructor(width: number, height: number);
}
export declare class HMSVideoTrackSettingsBuilder {
    private _width;
    private _height;
    private _codec;
    private _maxFramerate;
    private _maxBitrate;
    private _deviceId;
    private _advanced;
    setWidth(width: number): this;
    setHeight(height: number): this;
    codec(codec: HMSVideoCodec): this;
    maxFramerate(maxFramerate: number): this;
    maxBitrate(maxBitrate: number): this;
    deviceId(deviceId: string): this;
    advanced(advanced: Array<MediaTrackConstraintSet>): this;
    build(): HMSVideoTrackSettings;
}
export default class HMSVideoTrackSettings {
    readonly width: number;
    readonly height: number;
    readonly codec: HMSVideoCodec;
    readonly maxFramerate: number;
    readonly maxBitrate: number;
    readonly deviceId: string;
    readonly advanced: Array<MediaTrackConstraintSet>;
    constructor(width: number, height: number, codec: HMSVideoCodec, maxFramerate: number, maxBitrate: number, deviceId: string, advanced: Array<MediaTrackConstraintSet>);
    toConstraints(): MediaTrackConstraints;
}
