import HMSMediaStream from '../streams/HMSMediaStream';
import { HMSTrackType } from './HMSTrackType';
export declare type HMSTrackSource = 'regular' | 'screen' | 'plugin';
export default abstract class HMSTrack {
    source?: HMSTrackSource;
    abstract readonly type: HMSTrackType;
    get enabled(): boolean;
    get trackId(): string;
    getMediaTrackSettings(): MediaTrackSettings;
    setEnabled(value: boolean): Promise<void>;
    protected constructor(stream: HMSMediaStream, track: MediaStreamTrack, source?: HMSTrackSource);
}
